<template>
	<v-list-item @click="toDetails">
		<v-list-item-action>
			<v-checkbox v-model="task.done" @click.stop="updateTask" />
		</v-list-item-action>

		<v-list-item-content>
			<v-list-item-title v-text="task.description" />
			<v-list-item-subtitle v-if="taskDate" v-text="taskDate" />
		</v-list-item-content>

		<v-list-item-icon v-if="task.priority">
			<v-icon :color="getPriorityColor()">fa-star</v-icon>
		</v-list-item-icon>
	</v-list-item>
</template>

<script>
import { Task, getColor } from "@/models/Task";
import taskService from "@/mixins/TaskService";

export default {
	mixins: [taskService],

	props: {
		task: {
			type: [Task, Object],
			required: true
		}
	},

	computed: {
		routeLink() {
			return { name: "task", params: { id: this.task.id } };
		},

		taskDate() {
			return this.task.creationDate
				? new Date(this.task.creationDate).toLocaleDateString()
				: null;
		}
	},

	methods: {
		updateTask() {
			this.task.done = !this.task.done;
			this.$emit("update", this.task);

			if (typeof task !== Task) return;
			this.taskService.edit(this.task);
		},

		getPriorityColor() {
			return getColor(this.task.priority);
		},

		toDetails() {
			if (!this.task.priority) return;

			this.$router.push(this.routeLink);
		}
	}
};
</script>
